#include "nidsfindshellcode.h"
#include "ADMmut-misc.h"

extern struct _conf conf;

/****************************/
/* Main rutine that checks  */
/*  for shellcodes          */
/****************************/
void check_shellcode(struct _proto *proto, char *buffer, int len) {
char *ptr;
int counter_len, counter_nops, aux;
int found; 

 if ((len<0) || (len<NOPS_RAISE_ERROR)) return;

 /************************/
 /* Check for intel NOPS */
 /************************/
 counter_len=0;
 counter_nops=0;
 ptr=(char *)buffer;
 while(counter_len<len) {
    found=0; 
    for (aux=0;aux<IA32_JUNKS;aux++)       
         if ((!found) && (intel_njunk[aux].noppad)) {
              if (((intel_njunk[aux].dyn==0) && 
                 (strncmp(ptr,intel_njunk[aux].code,intel_njunk[aux].len)==0)) ||
                 ((intel_njunk[aux].dyn==1) &&
                 (strncmp(ptr,intel_njunk[aux].code,intel_njunk[aux].dynint)==0))) {
                            counter_nops++;
                            found=1;
                            ptr+=intel_njunk[aux].len-1;        
                            }
         }
    if (found==0) counter_nops=0;
    if (counter_nops==NOPS_RAISE_ERROR) raise_error(IA32_ERROR,proto,buffer,len);   
    ptr++;
    counter_len++; 
   }
  
 /************************/
 /* Check for sparc NOPS */
 /************************/
 counter_len=0;
 counter_nops=0;
 ptr=(char *)buffer;
 while(counter_len<len) {
    found=0;
    for (aux=0;aux<SPARC_JUNKS;aux++)
         if ((!found) && (sparc_njunk[aux].noppad)) {
              if (((sparc_njunk[aux].dyn==0) &&
                 (strncmp(ptr,sparc_njunk[aux].code,sparc_njunk[aux].len)==0)) ||
                 ((sparc_njunk[aux].dyn==1) &&
                 (strncmp(ptr,sparc_njunk[aux].code,sparc_njunk[aux].dynint)==0))) {
                            counter_nops++;
                            found=1;
                            ptr+=sparc_njunk[aux].len-1;
                            }
         }
    if (found==0) counter_nops=0;
    if (counter_nops==NOPS_RAISE_ERROR/4) raise_error(SPARC_ERROR,proto,buffer,len);
    ptr++;
    counter_len++;
   }

 /************************/
 /* Check for sparc HPPA */
 /************************/
 counter_len=0;
 counter_nops=0;
 ptr=(char *)buffer;
 while(counter_len<len) {
    found=0;
    for (aux=0;aux<HPPA_JUNKS;aux++)
         if ((!found) && (hppa_njunk[aux].noppad)) {
              if (((hppa_njunk[aux].dyn==0) &&
                 (strncmp(ptr,hppa_njunk[aux].code,hppa_njunk[aux].len)==0)) ||
                 ((hppa_njunk[aux].dyn==1) &&
                 (strncmp(ptr,hppa_njunk[aux].code,hppa_njunk[aux].dynint)==0))) {
                            counter_nops++;
                            found=1;
                            ptr+=hppa_njunk[aux].len-1;
                            }
         }
    if (found==0) counter_nops=0;
    if (counter_nops==NOPS_RAISE_ERROR/4) raise_error(HPPA_ERROR,proto,buffer,len);
    ptr++;
    counter_len++;
   }
 

}

void raise_error(int error,struct _proto *proto,char *data,int len) {
char buffer_aux[128];
char buffer[1024];
char ips[128], ipd[128];
int counter;
 
   memset(buffer,0,sizeof(buffer));
   memset(buffer_aux,0,sizeof(buffer_aux));
 
   sprintf(ips,"%s",resolve(proto->ips));
   sprintf(ipd,"%s",resolve(proto->ipd));
 
   if (error==IA32_ERROR) strcpy(buffer_aux,"IA32 shellcode found:");
      else if (error==SPARC_ERROR) strcpy(buffer_aux,"SPARC shellcode found:");
         else if (error==HPPA_ERROR) strcpy(buffer_aux,"HPPA shellcode found:");

   if (proto->protocol==IPPROTO_TCP) sprintf(buffer,"%s Protocol TCP %s:%d -> %s:%d\n",
                                             buffer_aux,ips,proto->sport,ipd,proto->dport);
      else if (proto->protocol==IPPROTO_UDP) sprintf(buffer,"%s Protocol UDP %s:%d -> %s:%d\n",
                                             buffer_aux,ips,proto->sport,ipd,proto->dport);
         else if (proto->protocol==IPPROTO_ICMP) sprintf(buffer,"%s Protocol ICMP %s -> %s Type: %d Code: %d\n",
                                             buffer_aux,ips,ipd,proto->type,proto->code);

   printf("%s",buffer);
   
  if (conf.verbose_flag) {
   printf("Dumping data:\n");
   for(counter=0;counter<len;counter++) {
      if (isprint(data[counter])) printf("%c",data[counter]);
              else printf(".");
        
      if ((counter%40==39))  printf("\n"); 
      }      
   
  if (counter%40!=39)printf("\n");
 }

   

 }
