#ifndef __NIDS_findshellcode_H__
#define __NIDS_findshellcode_H__

#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <netdb.h>
#include <inttypes.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <pcap.h>
#include <ctype.h>

#include "tcpip.h"

#define VERSION "0.2"

#define DEVICE_LEN 128

#define IA32_ERROR 0
#define SPARC_ERROR 1
#define HPPA_ERROR 2

#define NOPS_RAISE_ERROR 60

struct _conf {
  int verbose_flag;
  int promisc_flag;
  int resolve_flag;
  char device[DEVICE_LEN];
  };

struct _proto {
 int protocol;
 uint16_t sport;
 uint16_t dport;
 uint8_t type;
 uint8_t code;
 uint32_t ips;
 uint32_t ipd;
 };


/**************/
/* prototypes */
/**************/
void show_usage(char *);
void show_help(char *);
int get_datalink_offset(pcap_t *);
void check_shellcode(struct _proto *, char *, int);
void raise_error(int,struct _proto *, char *, int); 
char * resolve(uint32_t);
#endif
